 /* 

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation, either version 3 of the License,
or (at your option) any later version. This program is distributed
in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General
Public License along with this program. If not, see
<http://www.gnu.org/licenses/>.
Linking this library statically or dynamically with other modules
is making a combined work based on this library. Thus, the terms and
conditions of the GNU General Public License cover the whole combination.

As a special exception, the copyright holders of this library give
you permission to link this library with independent modules to
produce an executable, regardless of the license terms of these
independent modules, and to copy and distribute the resulting
executable under terms of your choice, provided that you also meet,
for each linked independent module, the terms and conditions of
the license of that module. An independent module is a module which is
not derived from or based on this library.
If you modify this library, you may extend this exception to your
version of the library, but you are not obligated to do so.
If you do not wish to do so, delete this exception statement from your
version.
*/
/* As15.java (c)2002, 2003, 2024 William Redelmeier
*
* Manipulates a graphic polygon.
*
* @author William Redelmeier 2002, 2003, 2024
*/
 // Under title Affine_Transformations_GUI 

import java.awt.*         ;
import java.awt.event.*   ;
import javax.swing.*      ;
import java.util.StringTokenizer;

public class As15 extends JPanel 
{
  // 	public  Axis CBAxis ;
	public String[] saxis = new String[]{"X Axis","Through Origin","Y Axis"};
 	public JComboBox<String> cbaxis = new JComboBox<>(saxis);   
	// Shape Declarations
   protected double rndup = .50 ;
   final private double L = 30;
   static JMenuBar menuBar = new JMenuBar();
    
   private graphicsCanvas gc = new graphicsCanvas();
   static JPanel fieldPanel = new JPanel();
   final int CX  = 56  ; // Spawn point coords
   final int CY  = 52  ;
   public volatile int cenx  = CX ; // 240 ; 
   public volatile int ceny  = CY ; // 40 ;   
   final private double[] mSquareXs   = 
   			{  L, -L  ,-L,  L  };
   final private double[] mSquareYs   = 
   			{  L, L,  -L,  -L };
   final private Pauly    mSquare     = 
   			 new Pauly (   "Square",
             new Point(0,0),
                          mSquareXs,
                          mSquareYs);

   final private double[]   mTriangleXs = 
   			{  L,     0,   -L    };
   final private double[]   mTriangleYs = 
   			{  L*2/3,   -L,   L*2/3     };
   final private Pauly mTriangle  = 
   			new Pauly("Triangle",
                              new Point(0,0),
                              mTriangleXs,
                              mTriangleYs);

   final private double[]   mnullXs = {  };
   final private double[]   mnullYs = {  };

   final private Pauly mnull = 
   					new Pauly ("null",
                    new Point(0, 0), mnullXs,
                    mnullYs);
   final private double[]   mRhombusXs = 
   				{-L,   0,   L,  -L  };
   final private double[]   mRhombusYs = 
   				{ L,   L,  -L,  -L  };
   final private Pauly      mRhombus   = 
   				    new Pauly (   "Rhombus",
                    new Point(0, 0),
                    mRhombusXs,
                    mRhombusYs);

   final private double[]   mPshapeXs  = 
   				{ -L,  L,  L, 0,  0, -L  };
   final private double[]   mPshapeYs  = 
   				{  L,  L,  0, 0, -L, -L  };
   final private Pauly      mPshape    = 
   				new Pauly (   "Pshape",
                    new Point(0,0),
                    mPshapeXs,
                    mPshapeYs);

   final private double[]   mNcpentXs  = 
   				{  L, -L, -L,  0,   L };
   final private double[]   mNcpentYs  = 
   				{ -L, -L,  L,  0,   L };
   final private Pauly      mNcpent    = 
   				new Pauly (   "Ncpent",
                    new Point(0,0),
                    mNcpentXs,
                    mNcpentYs);

   // Enumerate Transformations
   final private int    XSCALE      = 1,
                        YSCALE      = 2,
                        ROTATE      = 3,
                        TRANSLATE   = 4,
                        PROJECTION  = 5, 
                        OVSCAL      = 6;
					
	
		
   // Stateful Members - KEEP TO A MINIMUM!
//   private Pauly mPgon = mSquare.getCopy();

   private Pauly mPgon = mnull.getCopy()  ;

   public  Pauly drawpgon             ;
 
   private int  mnTransformation = ROTATE;  
   private JTextField tfcenpt          ;
   private JTextField tfrefpt         ;
   private JTextField tfxtrans        ;
   private JTextField tfytrans        ;
   private JTextField tfovscal        ;
   private JTextField tfxscal         ;
   private JTextField tfyscal         ;
   private JTextField tfminangle      ;
   private JTextField tfnlines        ;
   private JTextField tfdegrees       ;
   private int iselaxis 	;
   // Stateful Members End
   
    public As15(){}
    
public void init()
    {  
     int crefx = 0, 
	     crefy = 0 ; 
//		 JPopupMenu menuBar ; 
//	JMenuBar menuBar = new JMenuBar();  
//	JComboBox cbaxis ; 
    final  int xtrans = -40, ytrans = -10 ;
    final  int inaxis =   0              ;
    final  int axis   = 0  ;
	// int selaxis ; 
    int   nlines = 0       ;  // not final
    final  int minangle = 0, degrees = 45 ;
    final  double ovscal = 1.80 , 
	xscal = 0.8, yscal = 0.6 ;

// 1. Get handle on frame's content pane.
    this.setSize(600, 400);     // was , 1000) ; 
    this.setBackground(Color.blue);
    menuBar.setForeground(Color.black);
 
    menuBar = getMenuBar();  
    getMenu1();
    getMenu2();
  			
    // 6.33  Set up the graphicsCanvas 
//    gc = new graphicsCanvas();
    gc.setBackground(Color.BLACK);
    gc.setForeground(Color.WHITE);

    gc.setSize(getSize().width  - 24,  // -1 
    		getSize().height - 21 );

    add(gc, BorderLayout.CENTER);  // this.add
        
    // 6.5 Add the textfields and button
        fieldPanel.setBackground(Color.white);
        fieldPanel.setOpaque(true);

        fieldPanel.setLayout(
                new GridLayout(4,6));

        JLabel lcenpt = new JLabel("center pt");
        fieldPanel.add(lcenpt);

        tfcenpt = new JTextField(10);
        
     mPgon.calcCenPt();  // actually a calc                            
// tfcenpt.setText(cenx+", "+ceny) ;
//      System.out.println("tfcenpt reset.");
         
        
  tfcenpt.setText(Integer.toString(cenx)+", " +
        		Integer.toString(ceny));	
        tfcenpt.setEditable(false);

        fieldPanel.add(tfcenpt);

        JLabel lrefpt = new JLabel("ref pt");
        fieldPanel.add(lrefpt);

  tfrefpt = new JTextField(10);
  tfrefpt.setText(
  	Integer.toString(crefx)+", " +
	Integer.toString(crefy));        
    tfrefpt.setEditable(true);

    fieldPanel.add(tfrefpt);    

    JLabel lbutgo = new JLabel("Transform!");
        fieldPanel.add(lbutgo);

        JButton b_go = new JButton("Go!");
        fieldPanel.add(b_go);
        b_go.addActionListener(new GoListener());

        JLabel laxis = new JLabel("Choose axis");
        fieldPanel.add(laxis);

        // Create a Combo box
		
		cbaxis.addItemListener(
				new ItemListener(){
					public void itemStateChanged(ItemEvent e){
						iselaxis = cbaxis.getSelectedIndex();
					};
				}
			);
        fieldPanel.add(cbaxis);

        JLabel lxtrans = new JLabel("X transl");
        fieldPanel.add(lxtrans);

        tfxtrans = new JTextField(10);
        tfxtrans.setText(Integer.toString(xtrans));
        tfxtrans.setEditable(true);
        fieldPanel.add(tfxtrans);


        JLabel lytrans = new JLabel("Y transl");
        fieldPanel.add(lytrans);

        tfytrans = new JTextField(10);
        tfytrans.setText(Integer.toString(ytrans));
        tfytrans.setEditable(true);
        fieldPanel.add(tfytrans);


        JLabel lovscal = new JLabel("Ovr'l scg");
        fieldPanel.add(lovscal);

        tfovscal = new JTextField(10);
        tfovscal.setText(Double.toString(ovscal));
        tfovscal.setEditable(true);
        fieldPanel.add(tfovscal);


        JLabel lxscal = new JLabel("X scaling");
        fieldPanel.add(lxscal);

        tfxscal = new JTextField(10);
        tfxscal.setText(Double.toString(xscal));
        tfxscal.setEditable(true);
        fieldPanel.add(tfxscal);


        JLabel lyscal = new JLabel("Y scaling");
        fieldPanel.add(lyscal);

        tfyscal = new JTextField(10);
        tfyscal.setText(Double.toString(yscal));
        tfyscal.setEditable(true);
        fieldPanel.add(tfyscal);


        JLabel ldegrees = new JLabel("Degs Clockwz");
        fieldPanel.add(ldegrees);

        tfdegrees = new JTextField(10);
        tfdegrees.setText(Integer.toString(degrees));
        tfdegrees.setEditable(true);
        fieldPanel.add(tfdegrees);
 
        JLabel lnlines = new JLabel("num lines");
        fieldPanel.add(lnlines);

        tfnlines = new JTextField(10);
        tfnlines.setText(Integer.toString(nlines));
        tfnlines.setEditable(true);
        fieldPanel.add(tfnlines);


        JLabel lminangle = new JLabel("Min. angle");
        fieldPanel.add(lminangle);

        tfminangle = new JTextField(10);
        tfminangle.setText(Integer.toString(minangle));
        tfminangle.setEditable(false);
        fieldPanel.add(tfminangle);
		fieldPanel.setSize(600, 400);  // ??
        add(fieldPanel, BorderLayout.SOUTH);   // this.add   
}   // end of init

private void addTransformationMenuItem(
                    JMenu menu,
                    String  caption,
                    final int nTransformation)
{ 
    JMenuItem menuItem = new JMenuItem(caption);
    menu.add(menuItem)  ;
    menuItem.addActionListener 
        (
            new ActionListener()
            {
 public void actionPerformed(ActionEvent e)
                {
    mnTransformation   = nTransformation;
                }
            }
        );
}


public void addShapeMenuItem(JMenu menu,
                    final Pauly shape){
						
    JMenuItem menuItem = new JMenuItem(
    		shape.getCaption());
    menu.add(menuItem);
//	  var m1 = new JMenuItem("NC-Pentagon");
    menuItem.addActionListener
        (
            new ActionListener(){
  public void actionPerformed(ActionEvent e)
                {
  if(mPgon != null){  //freshly chosen
     
          cenx = CX ;
          ceny = CY  ; 
                    	 
    int minangle = 0 ; 
    tfminangle.setText(
    		Integer.toString(minangle));

    mPgon   = shape.getCopy();    
    mPgon.translate(cenx, ceny) ; 
    mPgon.calcCenPt();  // may not need this                   
    
    tfcenpt.setText(cenx+", "+ceny) ;
//    System.out.println("tfcenpt reset.");    
 
    tfnlines.setText(Integer.
    		toString(mPgon.mXs.length ));
    
    gc.repaint() ;

         }  // if mPgon
                }  // actionPerformed  
            }
        );
}



private class GoListener 
	implements ActionListener{ 
	
    public void actionPerformed(ActionEvent e){
  
        String soldtfx = tfcenpt.getText();
        StringTokenizer st1, st2 ; 
        String srx = "", sry= "" ;
        st1 = new StringTokenizer(
        		soldtfx, ", ");
        srx = st1.nextToken();
        sry = st1.nextToken();
       
//      Integerize reference point
        int 	rx = 0 , ry = 0 ;          
        String soldrefx = tfrefpt.getText();
  
        String srefx = "", srefy= "" ;
        st2 = new StringTokenizer(
        		soldrefx, ", ");
        srefx = st2.nextToken();
        srefy = st2.nextToken();
 
        rx  = Integer.parseInt(srefx);
        ry  = Integer.parseInt(srefy);                              
          
        switch  (mnTransformation)
        {

  case    XSCALE:
  String  sXscal = tfxscal.getText();
  double  dxscal = Double.parseDouble(sXscal);
  mPgon.xscale(dxscal, rx);
            break;
  case    YSCALE:
  String  sYscal = tfyscal.getText();
  double  dyscal = Double.parseDouble(sYscal);
  mPgon.yscale(dyscal, ry);
            break;


  case    ROTATE:
  String  sDeg  = tfdegrees.getText();
  double  deg   =  Double.parseDouble(sDeg);
  double  rad   =  Math.toRadians(deg);
                 
            mPgon.rotate(rad, rx, ry);
           
    String  sAcc  = tfminangle.getText()  ;
    int minangle  = Integer.parseInt(sAcc);

            minangle += deg     ;
            if(minangle >=  360)
                minangle -= 360 ;
            if(minangle <= -360)
                minangle += 360 ;
      tfminangle.setText(
      		Integer.toString(minangle));    
 
            break;

   case    TRANSLATE:
//    Point xyref = new Point() ;
   	String  sx  = tfxtrans.getText(),
            sy  = tfytrans.getText();
        int tx  = Integer.parseInt(sx),
            ty  = Integer.parseInt(sy);
 
       mPgon.translate(tx, ty);
        
            break;

        case    PROJECTION:
  //  int iselaxis =  0 ;  
        iselaxis = cbaxis.getSelectedIndex();
     // 		inaxis).toString() ;

            int factorx =  0 ;
            int factory =  0 ; 
            
 if(iselaxis == 0){
            factorx =  1 ;
            factory = -1 ;          }

 if(iselaxis == 1  ){
            factorx = -1 ;
            factory = -1 ;          }

 if(iselaxis  == 2  ){
            factorx = -1 ;
            factory =  1 ;          }
 
     mPgon.project(factorx, factory, 0, 0);
            break;

        case    OVSCAL:
     String  sFactor  =  tfovscal.getText();
     double  factor   =  
     	Double.parseDouble(sFactor);
                          
     mPgon.scale(factor, rx, ry);
        }
 //  System.out.println(
 //       "in GoLis cenx before "+cenx );
    mPgon.calcCenPt();                              
   tfcenpt.setText(cenx+", "+ceny) ;
 // System.out.println("cenx after "+cenx);
 
  gc.repaint();    
    
    }
}
 
 
 
  JMenuBar getMenuBar(){
	  
    JMenuBar mb = new JMenuBar();
    mb.add(getMenu1());
    mb.add(getMenu2());
    mb.add(getMenu3());
    return mb;
}

  JMenu getMenu1(){
    JMenu x = new JMenu("About");
    x.add(getAboutMenuItem());
    return x;
}
  JMenu getMenu2(){
    JMenu x = new JMenu("Polygon");

	addShapeMenuItem(x, mSquare);
	addShapeMenuItem(x, mTriangle);
	addShapeMenuItem(x, mRhombus);
	addShapeMenuItem(x, mPshape);
	addShapeMenuItem(x, mNcpent);	
	
 
    return x;
}
  JMenu getMenu3() {
    JMenu x = new JMenu("Transformation");
/*	
	private void addTransformationMenuItem(
                    JMenu menu,
                    String  caption,
                    final int nTransformation)
*/  
	addTransformationMenuItem(x, "X Scaling", 1);
	addTransformationMenuItem(x, "Y Scaling", 2);
	addTransformationMenuItem(x, "Rotation", 3);
	addTransformationMenuItem(x, "Translation", 4);
	addTransformationMenuItem(x, "Projection", 5);
	addTransformationMenuItem(x, "Overall Scaling", 6);
	
    return x;
} 
 
private class Pauly
{
    String  mCaption;
    Point   mRefPt ;
    int flag  = 1 ; 
    int flagy = 1 ; 
    double[] mXs;
    double[] mYs;
    int nPoints = 0 ; 
 
    public Pauly(String caption, 
    		Point pt, 
			double[] Xs, double[] Ys){
        mCaption   = caption;
        mRefPt = pt;
        mXs = Xs;
        mYs = Ys;
    } 
    public void calcCenPt(){  
    double avy= 0, avx  = 0 ;
    int n = this.nPoints ;
    if(n == 0){
        cenx =  0	;
        ceny =  0 	;        
    }
 
    if(n == 3 || n == 4){
    avx = 0 ; avy = 0 ; 	
    for(int i = 0; i < n ; i ++){ 
    avx +=  this.mXs[i] ;
    avy +=  this.mYs[i] ;    
    }
    avx /= n ; 
    avy /= n ;    
    double  retvalx = 0 ; 
    double  retvaly = 0 ; 
    if(avx > 0){
       retvalx = avx + rndup ;
 }else{retvalx = avx - rndup;}

    if(avy > 0){
        retvaly =  avy + rndup ;
  }else{retvaly =  avy - rndup ;}
 	  
    cenx =  (int)retvalx 	;
    ceny =  (int)retvaly 	;  }     
 
    if(n > 4){
        cenx =  (int)mXs[3] 	;
        ceny =  (int)mYs[3] 	;     
    }        }

    public String getCaption()
    {
        return mCaption;
    }
    public Pauly getCopy()
    {
   return new Pauly(mCaption,
                   (Point) mRefPt.clone(),
			       (double[])mXs.clone(), 
                   (double[])mYs.clone());
    }

public void paint(Graphics g, 
		Point origin, int h2){
	
  Polygon pgon = getPoly();
  int x   =  origin.x ;  
  int y   =  origin.y ;   
        
 

 Polygon drawpgon = new Polygon(
 	pgon.xpoints, pgon.ypoints, pgon.npoints);
        int w   = getSize().width  - 1,
            h   = getSize().height - 1,
            w2  = w/2 ;  

for(int i = 0 ; i < drawpgon.npoints ; i++){
  drawpgon.xpoints[i] = 
  		w2 + drawpgon.xpoints[i] ; 
  drawpgon.ypoints[i] = 
  	    h2 - drawpgon.ypoints[i] ; 
            }
 
      g.drawPolygon(drawpgon) ;
  
    }
 
    public void translate(int ptx, int pty)
    {
 
    	double matrix[][] = 
		{{1,0,ptx},{0,1,pty},{0,0,0}};
    	  matMult(this, matrix);                        
    }

    public void scale(double factor,
    		int rx, int ry){
     	    	    	
    	double matrix2[][] = 
       {{ factor, 0, rx*(1-factor)},
    	{ 0, factor, ry*(1-factor)},
		{ 0,      0, 1            }	};
    	  matMult(this, matrix2);         
    }

 public void xscale(double dxscal, int rx)
    {    	double matrix[][] = 
    		{{dxscal,0,rx*(1-dxscal ) },
    		{0,1,0},
			{0,0,0}};
        	  matMult(this, matrix);                 
    }

 public void yscale(double dyscal, int ry)
    {    	
    	double matrix[][] = 
		{{1,0,0},
    	{0,dyscal,ry*(1-dyscal)},
		{0,0,0}};
    	  matMult(this, matrix);    	
    }

    public void project(
    		int factorx, int factory,
    		int px, int py){
 
         int settfx = px; 
         int settfy = py; 

        if((factorx < 0) && (flag == -1 )){ 
             settfx   /=  -1  ;
 
            }

        if((factorx < 0) && (flag != -1 )){    
             settfx   *=  -1  ;     
 
            }
         flag *= -1 ;

 
        if((factory < 0) && (flagy == -1 )){   
             settfy   /=  -1  ;
 
            }

        if((factory < 0) && (flagy != -1 )){  
             settfy   *=  -1  ;     
            }
         flagy *= -1 ;
         
   tfcenpt.setText(settfx+", "+settfy);       
 
        nPoints = mXs.length;
 
    	double matrix[][] = 
	{{factorx,0,0},{0,factory,0},{0,0,0}};
    	  matMult(this, matrix);
     }

public void rotate(double rotation, 
		int rx, int ry){
        double trix, triy ;
		double cosi, sine, negsine ;
	 
  cosi = Math.cos(rotation) ;
  sine = Math.sin(rotation) ;    
  negsine = (-1 * sine) ;
// see "Hearn and Baker p 193 
  trix = (rx*(1- cosi))+(ry *sine);
  triy = (ry*(1- cosi))-(rx *sine);  
    	double matrix[][] = 
 
   {{cosi, negsine, trix},
    {sine, cosi,    triy},
	{0,    0,       0   }  };   	 
    		matMult(this, matrix);
}
    private  Polygon getPoly()
    {
        Polygon pgon = new Polygon();
        nPoints = mXs.length;
        for (int idx = 0; idx<nPoints; idx++)
 pgon.addPoint((int)mXs[idx], (int)mYs[idx]);
        String  sAcc  = tfminangle.getText()  ;
        int minangle  = Integer.parseInt(sAcc);
        if(mPgon != null){
tfminangle.setText(
		Integer.toString(minangle));    
 
    }
        return pgon;        }
    
 void matMult(Pauly p, double matrix[][]){   
    
      nPoints = mXs.length;
      double fx, fy;
      for (int idx = 0; idx<nPoints; idx++){
           fx =  (mXs[idx]* matrix[0][0]);
           fx += (mYs[idx]* matrix[0][1]);
           fx += (matrix [0][2]);  
           fy =  (mXs[idx]* matrix[1][0]);
           fy += (mYs[idx]* matrix[1][1]);
           fy += (matrix [1][2]);             
if(mXs[idx] <0 ){
	rndup = -0.50 ;}else{
	rndup = 0.50 ;	
	}
		fx += rndup  ;
           mXs[idx]= (int)(fx) ;
if(mYs[idx] <0 ){
   	rndup = -.50 ;}else{
   	rndup = 0.50 ;	
        	}       
		fy += rndup ; 
           mYs[idx]= (int)(fy) ;           
 //     if(matrix[2][2] != 0){
 //     	mXs[idx] = (int)(fx*matrix[2][2]);
 //     	mYs[idx] = (int)(fy*matrix[2][2]);      	
 //    	}
      
       }//for  
  }  // matMult
 }  // Pauly
       
class graphicsCanvas extends java.awt.Canvas{
    public graphicsCanvas(){}
    public void paint(Graphics g)
    {  
     	
        int w   = getSize().width  + 96,  // - 1 
            h   = getSize().height - 1,
            w2  = w/2,
            h2  = h/2;
       int 	x = 0 , y = 0 ; 
String soldtfx = tfrefpt.getText();                 
StringTokenizer st1 ; 
String srx = "", sry= "" ;
st1 = new StringTokenizer(soldtfx, ", ");
  srx = st1.nextToken();
  sry = st1.nextToken();
  int xref, yref  ;          
    x  = Integer.parseInt(srx);
    y  = Integer.parseInt(sry);
    g.clearRect(0, 0, w, h);
    g.drawLine  (w2,  0,  w2,   h);    // Y axis
    g.drawLine  (0,  h2,   w,  h2);    // X axis
    Point origin = new Point(x,y);   
    mPgon.paint(g, origin, h2);
            
       w2 += x ;
       h2 += y ;
    }

    public void update(Graphics g)
    {       paint(g);
    }
}
	public class ExitWindow extends WindowAdapter{
		public void windowClosing(WindowEvent ev){
    	System.exit(0); }	
     }	

public static void main(String[] args){
	 

//  was JFrame, below
     JFrame frame = new JFrame();
	 frame.setSize(600, 400);
     frame.setTitle(
     "Bill's Java 2.2 Rendering Demo");   
	     frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);  //was Frame.EXIT_ON_CLOSE 	 
//	 frame.addWindowListener(   // ef.addW
// 		new WindowAdapter(){
//        public void windowClosing(WindowEvent ev){
//     	System.exit(0); }	
//       });		 
	 
	 As15 ef = new As15();
	 ef.init();

     // TODOPaul VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV

    // create a menubar
//    JMenuBar mb = getMenuBar();

    // add menubar to frame
    frame.setJMenuBar(menuBar);

    // TODOPaul ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^




	  // TODOPaul frame.setJMenuBar(ef.menuBar);
//	 frame.add("North", menuBar);
     frame.add("Center", ef );  // was Center
     frame.add(fieldPanel, BorderLayout.SOUTH);   // this.add
	 frame.pack();   //?
//	  frame.setLayout(null);
//	 frame.setLocationRelativeTo(null);
	 frame.setVisible(true);	 
//
 
}
 

 static JMenuItem getAboutMenuItem() {
    JMenuItem m = new JMenuItem("About");
    m.addActionListener
            (
                    new ActionListener()
                    {
                        public void actionPerformed(ActionEvent e)
                        {

                            JOptionPane.showMessageDialog(null,
									"As15.java (c)2008, (c)2024 Wm Redelmeier \n"+
                                    "This program is written in Java 1.8 \n"+
                                            "It uses matrix multiplication,      \n"+
                                            "and the Polygon class.  Cartesian   \n"+
                                            "coordinates are used.  Pick a       \n"+
                                            "polygon and a transformation, then  \n"+
                                            "press the \'Go\' button.      \n"

                            );
                        }
                    }
            );
    return m;
}

	// }
}	// E.O.P.
